/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/base/Object','sap/ui/base/EventProvider','sap/ui/base/ManagedObjectObserver','sap/ui/Device',"sap/base/Log","sap/ui/thirdparty/jquery"],function(B,E,M,D,L,q){"use strict";var e=new E(),i,c,C;var H=B.extend("HeaderAdapter",{constructor:function(o,A){if(!o||!A){L.error("Cannot initialize: Invalid arguments.");return;}this._oHeader=o;this._oStyledPage=null;this._oTitleInfo=null;this._oSubTitleInfo=null;this._oBackButtonInfo=null;this._oAdaptOptions=A;}});H.prototype.adapt=function(){var s=this._oAdaptOptions.bStylePage,k=this._oAdaptOptions.bCollapseHeader;if(s){this._toggleStyle("sapF2Adapted",true,true);}this._adaptTitle();this._adaptBackButton();if(k){this._collapseHeader();}return this.getAdaptedContent();};H.prototype.getAdaptedContent=function(){return{oTitleInfo:this._oTitleInfo,oSubTitleInfo:this._oSubTitleInfo,oBackButtonInfo:this._oBackButtonInfo,oStyledPage:this._oStyledPage};};H.prototype._adaptTitle=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bMoveTitle!==true){return false;}this._oTitleInfo=this._detectTitle();this._oSubTitleInfo=this._detectSubTitle();var s=!!this._oTitleInfo||!!this._oSubTitleInfo;if(this._oTitleInfo){this._oTitleInfo.oControl.toggleStyleClass("sapF2AdaptedTitle",true);}return s;};H.prototype._adaptBackButton=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bHideBackButton!==true){return false;}var k,l=false;this._oBackButtonInfo=this._detectBackButton();if(this._oBackButtonInfo){k=this._oBackButtonInfo.oControl.getVisible();this._oBackButtonInfo.oControl.toggleStyleClass("sapF2AdaptedNavigation",k);l=true;}return l;};H.prototype._toggleStyle=function(s,A,S){var p=this._oHeader.getParent();if(!p){return;}this._oStyledPage=p;if(A===true){p.addStyleClass(s,S);}else if(A===false){p.removeStyleClass(s,S);}else if(A===undefined){p.hasStyleClass(s)?p.removeStyleClass(s,S):p.addStyleClass(s,S);}};H._isAdaptableHeader=function(o){if(!o||!f(o,"sap/m/Bar")){return false;}var p=o.getParent();return p&&(f(p,"sap/m/Page")||f(p,"sap/m/MessagePage")||f(p,"sap/uxap/ObjectPageHeader"));};H.prototype._detectTitle=function(){var t;if(H._isAdaptableHeader(this._oHeader)){var m=this._oHeader.getContentMiddle();if(m.length===1&&a(m[0])){var T=m[0];t={id:T.getId(),text:T.getText(),oControl:T,sChangeEventId:"_change",sPropertyName:"text"};}}return t;};H.prototype._detectSubTitle=function(p){if(f(p,"sap/uxap/ObjectPageHeader")){var o=p.getHeaderTitle();if(o){return{id:o.getId(),text:o.getObjectTitle(),oControl:o,sChangeEventId:"_titleChange",sPropertyName:"objectTitle"};}}};H.prototype._detectBackButton=function(){var k,o;if(H._isAdaptableHeader(this._oHeader)){k=this._oHeader.getContentLeft();if(k.length>0&&f(k[0],"sap/m/Button")&&(k[0].getType()==="Back"||k[0].getType()==="Up"||k[0].getIcon()==="sap-icon://nav-back")){o=k[0];return{id:o.getId(),oControl:o,sChangeEventId:"_change",sPropertyName:"visible"};}}};H.prototype._collapseHeader=function(){var t=this._oTitleInfo,k=this._oBackButtonInfo,l,m,n,o,p,r,A;if(H._isAdaptableHeader(this._oHeader)){l=this._oHeader.getContentLeft();m=this._oHeader.getContentMiddle();n=this._oHeader.getContentRight();o=(l.length===1)&&(h(l[0])||k);p=(m.length===1)&&(h(m[0])||t);r=(n.length===1)&&h(n[0]);A=(l.length===0||o)&&(m.length===0||p)&&((n.length===0)||r);this._toggleStyle("sapF2CollapsedHeader",A,true);}};var F=B.extend("sap.m.Fiori20Adapter",{});F.attachViewChange=function(l,o){e.attachEvent("adaptedViewChange",l,o);};F.detachViewChange=function(l,o){e.detachEvent("adaptedViewChange",l,o);};F.traverse=function(o,A){i={aViewTitles:{},aViewSubTitles:{},aViewBackButtons:{}};c={};C=null;this._doBFS([{oNode:o,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}};F._doBFS=function(Q){var n=Q.shift();if(!n){return;}var N=n.oNode,A=n.oAdaptOptions,s=A.iSearchDepth;A=this._applyRules(A,N);if(!this._isAdaptationRequired(N,A)||(s<=0)){return;}var I=this._isTopNavigableView(N);if(I){this._setAsCurrentlyAdaptedTopViewId(N.getId());}var o=this._processNode(N,A);var k=this._getNodeChildren(N),l=q.extend({},A,{iSearchDepth:this._updateSearchDepth(s,N)});if(o){var t=!!o.oTitleInfo,m=!!o.oBackButton,p=!!o.oStyledPage;l=q.extend(l,{bMoveTitle:A.bMoveTitle&&!t,bHideBackButton:A.bHideBackButton&&!m,bStylePage:A.bStylePage&&!p});}k.forEach(function(r){if(r){Q.push({oNode:r,oAdaptOptions:l});}});this._doBFS(Q);};F._processNode=function(o,A){this._attachDefferedAdaptationListeners(o,A);if(H._isAdaptableHeader(o)){return this._adaptHeader(o,A);}if(o.getParent()&&f(o.getParent(),"sap/m/NavContainer")){return this._getCachedViewInfoToMerge(o.getId());}};F._attachDefferedAdaptationListeners=function(o,A){this._attachAdaptableContentChange(o,A);this._attachNavigablePageChange(o,A);if(f(o,"sap/m/Page")||f(o,"sap/ui/core/mvc/XMLView")){this._observeAddAggregation(o,"content",A);}if(f(o,"sap/m/NavContainer")){this._observeRemoveAggregation(o,"pages",A);}if((A.bLateAdaptation===true)&&f(o,"sap/m/Bar")){this._observeAddAggregation(o,"contentLeft",A,o);this._observeAddAggregation(o,"contentMiddle",A,o);this._observeAddAggregation(o,"contentRight",A,o);}if(f(o,"sap/ui/core/ComponentContainer")){var k=o.getComponentInstance();if(!k&&o.getName()&&!o.getDomRef()){var t=this;var l={onBeforeRendering:function(){o.removeEventDelegate(l);t._doBFS([{oNode:o.getComponentInstance(),oAdaptOptions:A}]);if(t._getCurrentlyAdaptedTopViewId()){t._fireViewChange(t._getCurrentlyAdaptedTopViewId(),A);}}};o.addEventDelegate(l,this);}}};F._checkHasListener=function(o,s){var k=c[o.getId()];return k&&k[s];};F._setHasListener=function(o,s,l){var k=c[o.getId()];if(!k){k={};c[o.getId()]=k;}k[s]=l;};F._attachAdaptableContentChange=function(o,A){if(!o._getAdaptableContent||!q.isFunction(o._getAdaptableContent)){return;}if(this._checkHasListener(o,"_adaptableContentChange")){return;}var O=this._getCurrentlyAdaptedTopViewId();var k=function(l){var m=l.getParameter("adaptableContent");this._setAsCurrentlyAdaptedTopViewId(O);this._doBFS([{oNode:m,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}}.bind(this);o.attachEvent("_adaptableContentChange",k);this._setHasListener(o,"_adaptableContentChange",k);};F._attachNavigablePageChange=function(o,A){if(!f(o,"sap/m/NavContainer")){return;}if(this._checkHasListener(o,"navigate")){return;}var O=function(k){var n=k.getParameter("to");A=this._applyRules(A,n);this._doBFS([{oNode:n,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}}.bind(this);o.attachNavigate(O);this._setHasListener(o,"navigate",O);};F._observeAddAggregation=function(o,A,k,l){if(this._checkHasListener(o,A)){return;}var O=this._getCurrentlyAdaptedTopViewId(),m=function(p){var s=p.mutation,r=p.object;if((s==="add")||(s==="insert")){this._setAsCurrentlyAdaptedTopViewId(O);this._doBFS([{oNode:l?l:r,oAdaptOptions:k}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),k);}}}.bind(this),n=new M(m);n.observe(o,{aggregations:[A]});this._setHasListener(o,A,n);};F._observeRemoveAggregation=function(o,A,k){if(this._checkHasListener(o,A)){return;}var O=new M(this._onRemoveAggregation.bind(this));O.observe(o,{aggregations:[A]});this._setHasListener(o,A,O);};F._removeFromMergeInfo=function(m,o){Object.keys(m).forEach(function(k){var l=m[k];if((l.oControl===o)||j(l.oControl,o)){this._detachAllListeners(l.oControl);delete m[k];}},this);};F._detachAllListeners=function(o){var k=c[o.getId()];if(!k){return;}Object.keys(k).forEach(function(s){var l=k[s];if(l instanceof M){l.disconnect();}else{o.detachEvent(s,l);}delete k[s];});};F._onRemoveAggregation=function(o){var m=o.mutation,r;if(m==="remove"){r=o.child;this._detachAllListeners(r);this._removeFromMergeInfo(i.aViewTitles,r);this._removeFromMergeInfo(i.aViewSubTitles,r);this._removeFromMergeInfo(i.aViewBackButtons,r);}};F._getNodeChildren=function(o){if(o._getAdaptableContent&&q.isFunction(o._getAdaptableContent)){var k=[o._getAdaptableContent()];if(f(o,"sap/m/Page")){k=k.concat(o.getContent());}return k;}if(f(o,"sap/m/SplitContainer")){return[].concat(o.getAggregation("_navMaster"),o.getAggregation("_navDetail"));}if(f(o,"sap/uxap/ObjectPageLayout")){return[o.getHeaderTitle()];}if(f(o,"sap/ui/core/ComponentContainer")){return[o.getComponentInstance()];}if(f(o,"sap/ui/core/UIComponent")){return[o.getAggregation("rootControl")];}return o.findAggregatedObjects(false,g);};F._updateSearchDepth=function(s,o){if(f(o,"sap/ui/core/mvc/View")||f(o,"sap/ui/core/Component")||f(o,"sap/ui/core/ComponentContainer")){return s;}return s-1;};F._getTotalCachedInfoToMerge=function(v){var V=sap.ui.getCore().byId(v),o=this._getCachedViewInfoToMerge(v),k,l,s,S,m,p,n;if(!D.system.phone&&this._isTopSplitContainerSubView(V)){p=V.getParent();m=p&&p.getParent();if(m){k=m._oMasterNav&&(m._oMasterNav.getId()===p.getId());l=m._oDetailNav&&(m._oDetailNav.getId()===p.getId());}}if(k){s=m.getCurrentDetailPage();S=s&&s.getId();n=this._getCachedViewInfoToMerge(S);o=this._mergeSplitViewInfos(o,n);}if(l){s=m.getCurrentMasterPage();S=s&&s.getId();n=this._getCachedViewInfoToMerge(S);o=this._mergeSplitViewInfos(n,o);}o.sViewId=(k||l)?m.getId():v;return o;};F._isTopSplitContainerSubView=function(o){var p=o&&o.getParent();return this._isTopmostNavContainer(p)&&f(p.getParent(),"sap/m/SplitContainer");};F._mergeSplitViewInfos=function(m,o){q.each(m,function(k,v){m[k]=v||o[k];});return m;};F._getCachedViewInfoToMerge=function(v){var o=(i.aViewBackButtons[v])?i.aViewBackButtons[v].oControl:undefined;return{oTitleInfo:i.aViewTitles[v],oSubTitleInfo:i.aViewSubTitles[v],oBackButton:o};};F._applyRules=function(A,o){var p=o.getParent();if(f(p,"sap/m/SplitContainer")){var I=D.system.phone,m=A.bMoveTitle,k=A.bHideBackButton;if(m){m=I;}if(k&&!D.system.phone){k='initialPage';}return q.extend({},A,{bMoveTitle:m,bHideBackButton:k});}if(f(p,"sap/m/NavContainer")){if(A.bHideBackButton==='initialPage'){var l=p._getActualInitialPage()&&(p._getActualInitialPage().getId()===o.getId());return q.extend({},A,{bHideBackButton:l});}}if((A.bMoveTitle===false)||(A.bHideBackButton===false)){return q.extend({},A,{bCollapseHeader:false});}return A;};F._getCurrentlyAdaptedTopViewId=function(){return C;};F._setAsCurrentlyAdaptedTopViewId=function(v){C=v;};F._isTopNavigableView=function(n){var p=n.getParent();return p&&this._isTopmostNavContainer(p);};F._isTopmostNavContainer=function(o){var k,n=o;while(n){if(f(n,"sap/m/NavContainer")){k=n;}n=n.getParent();}return k&&(k.getId()===o.getId());};F._adaptHeader=function(o,A){if(!o||!A){return;}var k=new H(o,A),l=k.adapt();var t=this._getCurrentlyAdaptedTopViewId();if(l.oTitleInfo){i.aViewTitles[t]=l.oTitleInfo;this._registerTextChangeListener(i.aViewTitles,t,A);}if(l.oSubTitleInfo){i.aViewSubTitles[t]=l.oSubTitleInfo;this._registerTextChangeListener(i.aViewSubTitles,t,A);}if(l.oBackButtonInfo){if(l.oBackButtonInfo.oControl.getVisible()){i.aViewBackButtons[t]=l.oBackButtonInfo;}this._registerVisibilityChangeListener(l.oBackButtonInfo,i.aViewBackButtons,t,A);}return l;};F._registerTextChangeListener=function(t,v,A){var T=t[v];if(T&&T.oControl&&T.sChangeEventId){if(this._checkHasListener(T.oControl,T.sChangeEventId)){return;}var k=function(o){var T=t[v];if(o.getParameter("name")!==T.sPropertyName){return;}T.text=o.getParameter("newValue");this._fireViewChange(v,A);}.bind(this);T.oControl.attachEvent(T.sChangeEventId,k);this._setHasListener(T.oControl,T.sChangeEventId,k);}};F._registerVisibilityChangeListener=function(o,k,v,A){var V;if(o&&o.oControl&&o.sChangeEventId){if(this._checkHasListener(o.oControl,o.sChangeEventId)){return;}var l=function(m){if(m.getParameter("name")!==o.sPropertyName){return;}V=m.getParameter("newValue");if(!V){q.each(k,function(I,n){if(n.oControl.getId()===o.oControl.getId()){delete k[I];}});}var p=o.oControl.getParent();if(H._isAdaptableHeader(p)){F._adaptHeader(p,A);this._fireViewChange(v,A);}}.bind(this);o.oControl.attachEvent(o.sChangeEventId,l);this._setHasListener(o.oControl,o.sChangeEventId,l);}};F._fireViewChange=function(v,A){var t=this._getTotalCachedInfoToMerge(v);t.oAdaptOptions=A;e.fireEvent("adaptedViewChange",t);};F._isAdaptationRequired=function(n,A){if(!n||this._isNonAdaptableControl(n)){return false;}for(var o in A){if(A.hasOwnProperty(o)&&((A[o]===true)||(A[o]==="initialPage"))){return true;}}return false;};F._isNonAdaptableControl=function(o){return b(o);};function a(o){return d(o,["sap/m/Label","sap/m/Text","sap/m/Title"]);}function b(o){return d(o,["sap/m/List","sap/m/Table","sap/ui/table/Table","sap/ui/table/TreeTable"]);}function d(o,t){if(!o||!t){return;}return t.some(function(T){return f(o,T);});}function f(o,t){var T=sap.ui.require(t);return T&&(o instanceof T);}function g(o){return o&&(o.sParentAggregationName!=="dependents");}function h(o){return o&&(typeof o.getVisible==="function")&&(o.getVisible()===false);}function j(o,r){var p=o&&o.getParent();while(p){if(p===r){return true;}p=p.getParent();}return false;}return F;});
