/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/thirdparty/jquery','./Menu','./MenuItem','./MenuItemBase','./library','sap/ui/core/Control','./MenuBarRenderer','sap/ui/core/ResizeHandler','sap/ui/core/Popup','sap/ui/events/checkMouseEnterOrLeave','sap/ui/events/KeyCodes'],function(q,M,a,b,l,C,c,R,P,d,K){"use strict";var D=P.Dock;var e=l.MenuBarDesign;var f=C.extend("sap.ui.commons.MenuBar",{metadata:{library:"sap.ui.commons",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},design:{type:"sap.ui.commons.MenuBarDesign",group:"Appearance",defaultValue:e.Standard}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.unified.MenuItem",multiple:true,singularName:"item"}}}});var _=a.extend("sap.ui.commons._DelegatorMenuItem",{constructor:function(A){a.apply(this);this.oAlterEgoItm=A;this.bNoSubMenu=true;var s=this.oAlterEgoItm.getSubmenu();if(s){var t=this;s.getRootMenu=function(){return t.getParent();};this.bNoSubMenu=false;}},exit:function(){if(!this.bNoSubMenu){this.oAlterEgoItm.getSubmenu().getRootMenu=M.prototype.getRootMenu;}this.bNoSubMenu=true;this.oAlterEgoItm=null;},getText:function(){return this.oAlterEgoItm.getText();},getIcon:function(){return this.oAlterEgoItm.getIcon();},getEnabled:function(){return this.oAlterEgoItm.getEnabled();},getVisible:function(){return this.oAlterEgoItm.getVisible();},getSubmenu:function(){return this.oAlterEgoItm.getSubmenu();}});f.prototype.init=function(){this.oOvrFlwMnu=null;this.sCurrentFocusedItemRefId=null;this.data("sap-ui-fastnavgroup","true",true);};f.prototype.exit=function(){if(this.oOvrFlwMnu){this.oOvrFlwMnu.destroy();}this.oOvrFlwMnu=null;if(this.sResizeListenerId){R.deregister(this.sResizeListenerId);this.sResizeListenerId=null;}};f.prototype.doBeforeRendering=function(){var I=this.getItems();for(var i=0;i<I.length;i++){var m=I[i].getSubmenu();if(m){m.setRootMenuTopStyle(this.getDesign()==e.Header);}}if(this.oOvrFlwMnu){this.oOvrFlwMnu.setRootMenuTopStyle(this.getDesign()==e.Header);}if(this.sResizeListenerId){R.deregister(this.sResizeListenerId);this.sResizeListenerId=null;}};f.prototype.onAfterRendering=function(){this.sResizeListenerId=R.register(this.getDomRef(),q.proxy(this.onresize,this));this.onresize();};f.prototype.onresize=function(E){u(this);};f.prototype.onfocusin=function(E){var i=this.getId();var t=q(E.target);var T=t.attr("id");if(!T||T==i||T==i+"-area"){var I=this.$("area").children();this.sCurrentFocusedItemRefId=I.length==0?null:q(I.get(0)).attr("id");}else{this.sCurrentFocusedItemRefId=T;}var F=this.sCurrentFocusedItemRefId?document.getElementById(this.sCurrentFocusedItemRefId):null;if(F){F.focus();}this.$().attr("tabindex","-1");};f.prototype.onfocusout=function(E){this.$().attr("tabindex","0");};f.prototype.onmousedown=function(E){var m=h(this,E);if(m==="ovrflw"){this._bOvrFlwMnuSkipOpen=this.oOvrFlwMnu&&this.oOvrFlwMnu.bOpen;}else if(m){var i=m.getSubmenu();m._bSkipOpen=i&&i.bOpen;}};f.prototype.onmouseout=function(E){var m=h(this,E);if(m==="ovrflw"){var r=g(this,E);if(this._bOvrFlwMnuSkipOpen&&d(E,r[0])){this._bOvrFlwMnuSkipOpen=false;}}else if(m){var r=g(this,E);if(m._bSkipOpen&&d(E,r[0])){m._bSkipOpen=false;}}};f.prototype.onclick=function(E){o(this,E,false);};f.prototype.onsapselect=function(E){o(this,E,true);};f.prototype.onsapdown=function(E){o(this,E,true);};f.prototype.onsapdownmodifiers=function(E){if(E.altKey){o(this,E,true);}};f.prototype.onsapprevious=function(E){if(E.keyCode!=K.ARROW_UP){k(this,E,"prev");}};f.prototype.onsapnext=function(E){if(E.keyCode!=K.ARROW_DOWN){k(this,E,"next");}};f.prototype.onsaphome=function(E){k(this,E,"first");};f.prototype.onsapend=function(E){k(this,E,"last");};var o=function(t,E,w){E.preventDefault();E.stopPropagation();if(t.getEnabled()){var m=h(t,E);if(m==="ovrflw"){var r=g(t,E);if(t.oOvrFlwMnu&&!t._bOvrFlwMnuSkipOpen){var n=D;t.oOvrFlwMnu.open(w,r.get(0),n.EndTop,n.EndBottom,r.get(0));}}else if(m){if(m.getEnabled()){var r=g(t,E);var p=m.getSubmenu();if(p&&!m._bSkipOpen){var n=D;p.open(w,r.get(0),n.BeginTop,n.BeginBottom,r.get(0));}else if(!p){m.fireSelect({item:m});}}}}t._bOvrFlwMnuSkipOpen=false;var I=t.getItems();for(var i=0;i<I.length;i++){I[i]._bSkipOpen=false;}};var g=function(t,E){var r=q(E.target);if(!r.attr("itemidx")){r=r.parent();}return r.attr("itemidx")?r:null;};var h=function(t,E){var r=g(t,E);if(r){var i=r.attr("itemidx");if(i){if(i=="ovrflw"){return"ovrflw";}else{var I=parseInt(i);var m=t.getItems()[I];return m;}}}return null;};var j=function(t){var v=0;var A=t.$("area");var i=A.children();var r=sap.ui.getCore().getConfiguration().getRTL();var m=(r?100000:0);i.each(function(I){if(I==0){return true;}var n=this.offsetLeft;var L=(r?(n>=m):(n<=m));if(L){v=I;return false;}else if(q(this).attr("id")==t.getId()+"-ovrflw"){v=I;return false;}else{m=n;return true;}});return v;};var u=function(t){var v=j(t);var m=v;var A=t.$("area");var I=A.children();var O=t.$("ovrflw");var U=false;if(v<I.length-1){O.attr("style","display:block;");if(!t.oOvrFlwMnu){t.oOvrFlwMnu=new M(t.getId()+"-ovrflwmnu");t.oOvrFlwMnu.bUseTopStyle=t.getDesign()==e.Header;t.oOvrFlwMnu.attachItemSelect(function(E){var p=E.getParameter("item");if(!(p instanceof _)){var r=M.prototype.getRootMenu.apply(p.getParent());r.fireItemSelect({item:p});}else if(p.bNoSubMenu&&p instanceof _){p.oAlterEgoItm.fireSelect({item:p.oAlterEgoItm});}});}t.oOvrFlwMnu.destroyItems();var n=t.getItems();for(var i=0;i<n.length;i++){var p=n[i];if(v!=0){if(p.getVisible()){v--;}if(v==0){t.sLastVisibleItemId=p.getId();}}else{t.oOvrFlwMnu.addItem(new _(p));if(p.getId()==t.sCurrentFocusedItemRefId){U=true;}}}if(sap.ui.getCore().getConfiguration().getAccessibility()){I.attr("aria-setsize",m+1);O.attr("aria-posinset",m+1);}}else{O.attr("style","display:none;");if(t.oOvrFlwMnu){t.oOvrFlwMnu.destroyItems();}t.sLastVisibleItemId=null;if(sap.ui.getCore().getConfiguration().getAccessibility()){I.attr("aria-setsize",m);O.attr("aria-posinset",0);}}A.scrollTop(0);if(U){t.sCurrentFocusedItemRefId=t.sLastVisibleItemId;document.getElementById(t.sLastVisibleItemId).focus();}};var k=function(t,E,s){E.stopPropagation();E.preventDefault();if(!t.sCurrentFocusedItemRefId){return;}var F=null;if(t.sLastVisibleItemId&&((t.sCurrentFocusedItemRefId==t.sLastVisibleItemId&&s=="next")||s=="last")){F=t.getId()+"-ovrflw";}else if(t.sLastVisibleItemId&&t.sCurrentFocusedItemRefId==t.getId()+"-ovrflw"&&s=="prev"){F=t.sLastVisibleItemId;}else{var i=s+"All";var I=false;if(s=="first"){i="prevAll";I=true;}else if(s=="last"){i="nextAll";I=true;}var m=q(document.getElementById(t.sCurrentFocusedItemRefId));var n=m[i](":visible");F=q(n.get(I?n.length-1:0)).attr("id");}if(F){t.sCurrentFocusedItemRefId=F;document.getElementById(F).focus();}};return f;});
