/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/thirdparty/jquery','./PositionContainer','sap/ui/commons/library','sap/ui/core/Control','./AbsoluteLayoutRenderer','sap/ui/core/library'],function(q,P,l,C,A,c){"use strict";var S=c.Scrolling;var a=C.extend("sap.ui.commons.layout.AbsoluteLayout",{metadata:{library:"sap.ui.commons",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},verticalScrolling:{type:"sap.ui.core.Scrolling",group:"Behavior",defaultValue:S.Hidden},horizontalScrolling:{type:"sap.ui.core.Scrolling",group:"Behavior",defaultValue:S.Hidden}},defaultAggregation:"positions",aggregations:{positions:{type:"sap.ui.commons.layout.PositionContainer",multiple:true,singularName:"position"}}}});a.prototype.setWidth=function(w){return s(this,"width",w,"LYT_SIZE");};a.prototype.setHeight=function(h){return s(this,"height",h,"LYT_SIZE");};a.prototype.setVerticalScrolling=function(v){return s(this,"verticalScrolling",v,"LYT_SCROLL");};a.prototype.setHorizontalScrolling=function(h){return s(this,"horizontalScrolling",h,"LYT_SCROLL");};a.prototype.insertPosition=function(p,i){var h=!!this.getDomRef();this.insertAggregation("positions",p,i,h);if(h&&p&&p.getControl()){this.contentChanged(p,"CTRL_ADD");}return this;};a.prototype.addPosition=function(p){var h=!!this.getDomRef();this.addAggregation("positions",p,h);if(h&&p&&p.getControl()){this.contentChanged(p,"CTRL_ADD");}return this;};a.prototype.removePosition=function(p){var h=!!this.getDomRef();var r=this.removeAggregation("positions",p,h);if(r){d([r]);this.contentChanged(r,"CTRL_REMOVE");}return r;};a.prototype.removeAllPositions=function(){d(this.getPositions());var h=!!this.getDomRef();var r=this.removeAllAggregation("positions",h);if(h){this.contentChanged(r,"CTRL_REMOVE_ALL");}return r;};a.prototype.destroyPositions=function(){d(this.getPositions());var h=!!this.getDomRef();this.destroyAggregation("positions",h);if(h){this.contentChanged(null,"CTRL_REMOVE_ALL");}return this;};a.prototype.getContent=function(){var g=[];var p=this.getPositions();for(var i=0;i<p.length;i++){g.push(p[i].getControl());}return g;};a.prototype.addContent=function(o,p){var g=P.createPosition(o,p);this.addPosition(g);return this;};a.prototype.insertContent=function(o,i,p){var g=P.createPosition(o,p);this.insertPosition(g,i);return this;};a.prototype.removeContent=function(v){var i=v;if(typeof(v)=="string"){v=sap.ui.getCore().byId(v);}if(typeof(v)=="object"){i=this.indexOfContent(v);}if(i>=0&&i<this.getContent().length){this.removePosition(i);return v;}return null;};a.prototype.removeAllContent=function(){var g=this.getContent();this.removeAllPositions();return g;};a.prototype.indexOfContent=function(o){var g=this.getContent();for(var i=0;i<g.length;i++){if(o===g[i]){return i;}}return-1;};a.prototype.destroyContent=function(){this.destroyPositions();return this;};a.prototype.setPositionOfChild=function(o,p){var i=this.indexOfContent(o);if(i>=0){var g=this.getPositions()[i];g.updatePosition(p);return true;}return false;};a.prototype.getPositionOfChild=function(o){var i=this.indexOfContent(o);if(i>=0){var p=this.getPositions()[i];return p.getComputedPosition();}return{};};a.prototype.exit=function(){d(this.getPositions());};a.prototype.doBeforeRendering=function(){var p=this.getPositions();if(!p||p.length==0){return;}for(var i=0;i<p.length;i++){var o=p[i];o.reinitializeEventHandlers(true);e(o,true);}};a.prototype.onAfterRendering=function(){var p=this.getPositions();if(!p||p.length==0){return;}for(var i=0;i<p.length;i++){p[i].reinitializeEventHandlers();}};a.cleanUpControl=function(o){if(o&&o[b]){o.removeDelegate(o[b]);o[b]=undefined;}};a.prototype.contentChanged=function(p,g){switch(g){case"CTRL_POS":A.updatePositionStyles(p);e(p);p.reinitializeEventHandlers();break;case"CTRL_CHANGE":e(p,true);A.updatePositionedControl(p);p.reinitializeEventHandlers();break;case"CTRL_REMOVE":A.removePosition(p);p.reinitializeEventHandlers(true);break;case"CTRL_REMOVE_ALL":A.removeAllPositions(this);var h=p;if(h){for(var i=0;i<h.length;i++){h[i].reinitializeEventHandlers(true);}}break;case"CTRL_ADD":e(p,true);A.insertPosition(this,p);p.reinitializeEventHandlers();break;case"LYT_SCROLL":A.updateLayoutScolling(this);break;case"LYT_SIZE":A.updateLayoutSize(this);break;}};var b="__absolutelayout__delegator";var d=function(p){for(var i=0;i<p.length;i++){var o=p[i];var g=o.getControl();if(g){a.cleanUpControl(g);}}};var e=function(p,r){var o=p.getControl();if(o){a.cleanUpControl(o);if(!r){f(o);}var D=(function(g){return{onAfterRendering:function(){f(g);}};}(o));o[b]=D;o.addDelegate(D,true);}};var f=function(o){var g=false;if(o.getParent()&&o.getParent().getComputedPosition){var p=o.getParent().getComputedPosition();if(p.top&&p.bottom||p.height){q(o.getDomRef()).css("height","100%");g=true;}if(p.left&&p.right||p.width){q(o.getDomRef()).css("width","100%");g=true;}if(g){A.updatePositionStyles(o.getParent());}}return g;};var s=function(t,p,v,g){var h=!!t.getDomRef();t.setProperty(p,v,h);if(h){t.contentChanged(null,g);}return t;};P.cleanUpControl=a.cleanUpControl;return a;});
