/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/support/Plugin',"sap/ui/performance/Measurement","sap/base/security/encodeXML"],function(P,M,c){"use strict";var _=[];var d=0;var f=0;var g=250;var h=false;var j;var k={selectedInterval:{start:0,end:0},nodes:{slider:null,handle:null,leftResizeHandle:null,rightResizeHandle:null},consts:{LEFT_HANDLE_ID:'left',RIGHT_HANDLE_ID:'right'},sizes:{width:0,handleWidth:0,handleMinWidth:10},drag:{handleClickOffsetX:0,handleOffsetLeft:0,isResize:false,whichResizeHandle:''}};var l=P.extend("sap.ui.core.support.plugins.Performance",{constructor:function(o){P.apply(this,["sapUiSupportPerf","Performance",o]);j=this;this._oStub=o;if(this.runsAsToolPlugin()){this._aEventIds=[this.getId()+"SetMeasurements",this.getId()+"SetActive"];}else{this._aEventIds=[this.getId()+"Refresh",this.getId()+"Clear",this.getId()+"Start",this.getId()+"End",this.getId()+"Activate"];}}});l.prototype.init=function(o){P.prototype.init.apply(this,arguments);if(this.runsAsToolPlugin()){m.call(this,o);}else{n.call(this,o);}};l.prototype.exit=function(o){P.prototype.exit.apply(this,arguments);};function m(o){var a=sap.ui.getCore().createRenderManager();a.write(u());a.flush(this.$().get(0));a.destroy();x();}function n(o){p.call(this);}function p(o){var a=M.getAllMeasurements(true);this._oStub.sendEvent(this.getId()+"SetMeasurements",{"measurements":a});}l.prototype.onsapUiSupportPerfSetMeasurements=function(e){var a=e.getParameter("measurements");this.setData(a);};l.prototype.onsapUiSupportPerfRefresh=function(e){p.call(this);};l.prototype.onsapUiSupportPerfClear=function(e){M.clear();this._oStub.sendEvent(this.getId()+"SetMeasurements",{"measurements":[]});};l.prototype.onsapUiSupportPerfStart=function(e){M.start(this.getId()+"-perf","Measurement by support tool");};l.prototype.onsapUiSupportPerfEnd=function(e){M.end(this.getId()+"-perf");p.call(this);};l.prototype.onsapUiSupportPerfActivate=function(e){M.setActive(true);};l.prototype.setData=function(e){var i=document.querySelector('#sapUiSupportNoDataOverlay');var o=document.querySelector('#slider');var e1=document.querySelector('#sapUiSupportPerfHeaderTimelineOverview .timeline');if(e.length===0){i.style.display='block';o.classList.add('sapUiSupportHidden');e1.innerHTML='';return;}else{o.classList.remove('sapUiSupportHidden');i.style.display='';}_=(JSON.parse(JSON.stringify(e)));_=_.sort(function(a,b){return a.start-b.start;});var f1=e[0].start;_=_.map(function(a){a.start=parseFloat((a.start-f1).toFixed(2));a.end=parseFloat((a.end-f1).toFixed(2));a.uid=w();return a;});f=_[_.length-1].end-_[0].start;k.selectedInterval.start=_[0].start;k.selectedInterval.end=_[_.length-1].end;V();A(_);B(_);T();};var t=10;var q=0;var r;function s(e){clearInterval(r);if(h){h=false;j._oStub.sendEvent(j.getId()+"End");e.target.setAttribute('data-state','Start recording ('+(q/1000).toFixed(2)+' s)');}else{q=0;h=true;j._oStub.sendEvent(j.getId()+"Activate");j._oStub.sendEvent(j.getId()+"Clear");j._oStub.sendEvent(j.getId()+"Start");e.target.setAttribute('data-state','Stop recording ('+(q/1000).toFixed(2)+' s)');r=setInterval(function(){q+=t;e.target.setAttribute('data-state','Stop recording ('+(q/1000).toFixed(2)+' s)');},t);}}function u(){return''+'<section id="sapUiSupportPerf">'+'<section id="sapUiSupportNoDataOverlay"></section>'+'<section id="sapUiSupportPerfHeader">'+'<div class="sapUiSupportToolbar">'+'<label class="sapUiSupportLabel">Order:</label>'+'<select id="sapUiSupportPerfHeaderFilterSort" class="sapUiSupportTxtFld sapUiSupportSelect" name="orderBy">'+'<option value="chronologically">Chronologically</option>'+'<option value="time">By Time</option>'+'<option value="duration">By Duration</option>'+'</select>'+'<label class="sapUiSupportLabel">Min. Duration:</label>'+'<input id="sapUiSupportPerfHeaderFilterMinDuration" type="number" min="0" value="0">'+'<label class="sapUiSupportLabel"> ms.</label>'+'<div class="flex-spacer"></div>'+'<div id="categories"></div>'+'</div>'+'<section id="sapUiSupportPerfHeaderTimelineOverview">'+'<div class="timeline"></div>'+'<button id="sapUiSupportPerfToggleRecordingBtn"></button>'+'<div id="slider">'+'<div id="slideHandle">'+'<span id="leftHandle"></span>'+'<span id="rightHandle"></span>'+'</div>'+'</div>'+'</section>'+'</section>'+'<section id="sapUiSupportPerfHeaderTimeline">'+'<div id="sapUiSupportPerfHeaderTimelineBarInfoWrapper"></div>'+'<div id="sapUiSupportPerfHeaderTimelineBarWrapper"></div>'+'</section>'+'</section>';}function v(i){return _.reduce(function(a,b){if(b.uid===i){a=b;}return a;},null);}function w(){return'uID-'+(w.id!==undefined?++w.id:w.id=0);}function x(){document.querySelector('#sapUiSupportPerfHeaderFilterSort').addEventListener('change',B,false);document.querySelector('#sapUiSupportPerfHeaderFilterMinDuration').addEventListener('change',B,false);document.querySelector('#categories').addEventListener('change',B,false);document.querySelector('#sapUiSupportPerfHeaderTimelineBarWrapper').addEventListener('mouseover',K,false);document.querySelector('#sapUiSupportPerfHeaderTimelineBarInfoWrapper').addEventListener('mouseover',K,false);window.addEventListener('resize',function(){B();W();},false);window.addEventListener('keydown',Z);jQuery("#slideHandle").on('dblclick',V);jQuery("#sapUiSupportPerfToggleRecordingBtn").on("click",s).attr('data-state','Start recording');}function y(a,b){return'Duration: '+a.toFixed(2)+' ms.\nTime: '+b.toFixed(2)+' ms.';}function z(a){var b=50;var e=f/b;var o=[];for(var i=0;i<b;i++){var e1=e*i;var f1=e1+e;var g1=S({start:e1,end:f1},a);var h1=g1.map(function(l1){return{category:l1.categories[0],duration:l1.duration};});var i1={_total:0};h1.map(function(l1){if(!i1[l1.category]){i1[l1.category]=0;}i1._total+=l1.duration;i1[l1.category]=i1[l1.category]+l1.duration;});var j1=g1.map(function(l1){return{category:l1.categories[0],time:l1.time};});var k1={_total:0};j1.map(function(l1){if(!k1[l1.category]){k1[l1.category]=0;}k1._total+=l1.time;k1[l1.category]=k1[l1.category]+l1.time;});o.push({duration:i1,time:k1});}return o;}function A(a){var e=document.querySelector('#sapUiSupportPerfHeaderTimelineOverview .timeline');var i='<ol>';var o=(JSON.parse(JSON.stringify(a)));var e1=o.map(function(b){return b.duration;}).reduce(function(k1,b){return k1+b;});var f1=o.map(function(b){return b.time;}).reduce(function(k1,b){return k1+b;});var g1=z(o);var h1={time:{_total:0}};var i1={duration:{_total:0}};g1.forEach(function(b){if(h1.time._total<b.time._total){h1=b;}if(i1.duration._total<b.duration._total){i1=b;}});f1=h1.time._total;e1=i1.duration._total;function j1(b,k1){var i='';Object.keys(b.duration).sort().forEach(function(l1){if(l1!=='_total'){var m1=(b[k1][l1]/b[k1]._total)*100;i+='<div class="'+G(l1)+'" style="height: '+m1.toFixed(2)+'%;"></div>';}});return i;}g1.forEach(function(b){var k1=Math.ceil((b.duration._total/e1)*100);var l1=Math.ceil((b.time._total/f1)*100);var m1='height: '+k1+'%;';if(k1>0){m1+=' min-height: 1px;';}var n1='height: '+l1+'%;';if(l1>0){n1+=' min-height: 1px;';}i+='<li>';i+='<div class="bars-wrapper" title="'+y(b.duration._total,b.time._total)+'">';i+='<div class="duration" style="'+m1+'">';i+=j1(b,'duration');i+='</div>';i+='<div class="time" style="'+n1+'">';i+=j1(b,'time');i+='</div>';i+='</div></li>';});i+='</ol>';e.innerHTML=i;}function B(){var a='<ol>';var b='<ol>';var e=N();var i=L(_,e);if(i.length===0){a+='<li class="line nodata" data-uid="'+-1+'"></li>';b+='<li class="line nodata" data-uid="'+-1+'"><div class="info line">No data</div></li>';}i.forEach(function(o){var e1=v(o.uid);a+='<li data-uid="'+o.uid+'" class="line" title="'+E(e1)+'"'+J(e1)+'  >';a+='<div class="bar '+H(e1.duration)+'" style="width: '+C(o.duration)+' margin-left: '+D(o,e.filterByTime.start)+'">';a+='<div class="sub-bar '+H(e1.time)+'" style="width: '+C(o.time)+'"></div>';a+='</div>';a+='</li>';b+='<li data-uid="'+o.uid+'" title="'+E(e1)+'" class="line '+G(e1.categories[0])+'" '+J(e1)+'>';b+='<div class="info line">'+F(e1)+' ('+(e1.time).toFixed(0)+' ms)</div>';b+='</li>';});a+='</ol>';b+='</ol>';document.querySelector('#sapUiSupportPerfHeaderTimelineBarWrapper').innerHTML=a;document.querySelector('#sapUiSupportPerfHeaderTimelineBarInfoWrapper').innerHTML=b;U(e);O();}function C(a){var b=(a*d);var e=Math.max(b,1);return e+'px;';}function D(b,a){var o=(b.start-a)*d;return o.toFixed(0)+'px';}function E(b){return c(b.info+'\nduration: '+b.duration.toFixed(2)+' ms. \ntime: '+b.time.toFixed(2)+' ms. \nstart: '+b.start.toFixed(2)+' ms.\nend: '+b.end.toFixed(2)+' ms.');}function F(b){var a=b.info;a=a.substring(a.lastIndexOf('/')+1,a.length);a=a.substring(a.lastIndexOf('sap.m.'),a.length);a=a.replace('Rendering of ','');return c(a);}function G(a){var b='unknownType';if(a.indexOf("require")!==-1){b='requireModuleType';}else if(a.indexOf("xmlhttprequest")!==-1){b='requestType';}else if(a.indexOf("javascript")!==-1){b='afterRenderingType';}else if(a.indexOf("rendering")!==-1){b='renderingType';}return c(b);}function H(a){var b='';if(a>200){b='oneTimeStyle';}if(a>500){b='twoTimeStyle';}if(a>1000){b='threeTimeStyle';}if(a>2000){b='fourTimeStyle';}if(a>3000){b='fiveTimeStyle';}if(a>4000){b='sixTimeStyle';}return b;}function I(a){var b=[];a.forEach(function(i){if(b.indexOf(i.categories[0])===-1){b.push(i.categories[0]);}});return b;}function J(b){return'data-item-category = '+b.categories[0];}function K(e){var a=e.srcElement;if(a.classList.contains('info')&&a.nodeName==='DIV'){a=a.parentNode;}if(a.nodeName==='LI'){var b=a.getAttribute('data-uid');var i=document.querySelector('#sapUiSupportPerfHeaderTimelineBarInfoWrapper li.hover');var o=document.querySelector('#sapUiSupportPerfHeaderTimelineBarWrapper li.hover');if(i&&o){i.classList.remove('hover');o.classList.remove('hover');}var e1=document.querySelector('#sapUiSupportPerfHeaderTimelineBarInfoWrapper li[data-uid="'+b+'"]');var f1=document.querySelector('#sapUiSupportPerfHeaderTimelineBarWrapper li[data-uid="'+b+'"]');if(e1&&f1){e1.classList.add('hover');f1.classList.add('hover');}}}function L(a,b){var e=(JSON.parse(JSON.stringify(a)));var i=document.querySelector('#sapUiSupportPerfHeaderTimeline').offsetWidth-document.querySelector('#sapUiSupportPerfHeaderTimelineBarInfoWrapper').offsetWidth;var o=20;var e1=1;e=S(b.filterByTime,e);e=Q(b.orderByValue,e);e=R(b.minValue,e);if(e.length){e1=b.filterByTime.end-b.filterByTime.start;}d=((i-o)/e1);return e;}function N(){var o={};var a=document.querySelector('#sapUiSupportPerfHeaderFilterSort');o.orderByValue=a.options[a.selectedIndex].value;o.minValue=document.querySelector('#sapUiSupportPerfHeaderFilterMinDuration').valueAsNumber||0;o.filterByTime={start:k.selectedInterval.start,end:k.selectedInterval.end};return o;}function O(){var a=document.querySelectorAll('#categories input');function b(e,e1){var f1=G(e);var g1=document.querySelectorAll('li[data-item-category="'+e+'"]');var h1=document.querySelectorAll('.timeline .bars-wrapper .'+f1);for(var i=0;i<g1.length;i++){g1[i].style.display=e1?'':'none';}for(var o=0;o<h1.length;o++){h1[o].style.display=e1?'':'none';}}for(var i=0;i<a.length;i++){b(a[i].name,a[i].checked);}}function Q(o,e){if(o==='time'||o==='duration'){document.querySelector('body').classList.add('flattenBarOffset');}else{document.querySelector('body').classList.remove('flattenBarOffset');}if(o==='time'){e=e.sort(function(a,b){if(a.time>b.time){return-1;}if(a.time<b.time){return 1;}return 0;});}if(o==='duration'){e=e.sort(function(a,b){if(a.duration>b.duration){return-1;}if(a.duration<b.duration){return 1;}return 0;});}return e;}function R(a,b){return b.filter(function(i){return(i.duration>=a);});}function S(o,a){return a.filter(function(i){return!(i.end<=o.start||i.start>=o.end);}).map(function(i){var b=Math.max(o.start-i.start,0);var e=Math.max((i.start+i.time)-o.end,0);i.time=i.time-b-e;var e1=Math.max(o.start-i.start,0);var f1=Math.max((i.start+i.duration)-o.end,0);i.duration=i.duration-e1-f1;i.start=Math.max(i.start,o.start);i.end=Math.min(i.end,o.end);return i;});}function T(){var a='';var b=I(_);b.forEach(function(i){i=c(i);a+='<label title="'+i+'"><input class="'+G(i)+'" checked type="checkbox" name="'+i+'">'+i+'</label>';});var e=document.querySelector('#categories');e.innerHTML=a;}function U(a){var b=document.getElementById('sapUiSupportPerfHeaderTimelineBarWrapper');var e=Math.round(b.offsetWidth/10);var o=a.filterByTime.end-a.filterByTime.start;var e1=parseInt(o/e);if(document.getElementById('grid')){document.getElementById('grid').parentNode.removeChild(document.getElementById('grid'));}var f1=document.createElement('div');f1.innerHTML='<div class="header"></div><div class="body"></div>';f1.id='grid';for(var i=1;i<=e;i++){var g1=document.createElement('div');var h1=document.createElement('div');if(i%5===0||i===1){var i1=parseInt(a.filterByTime.start);if(i!==1){i1+=i*e1;}i1=i1>500?(i1/1000).toFixed(2)+' s':i1+' ms';h1.setAttribute('data-time',i1);}f1.querySelector('.body').appendChild(g1);f1.querySelector('.header').appendChild(h1);}document.querySelector('#sapUiSupportPerf').appendChild(f1);}function V(){k.nodes.slider=k.nodes.slider||document.querySelector('#slider');k.nodes.handle=k.nodes.handle||document.querySelector('#slideHandle');k.nodes.leftResizeHandle=k.nodes.leftResizeHandle||document.querySelector('#leftHandle');k.nodes.rightResizeHandle=k.nodes.rightResizeHandle||document.querySelector('#rightHandle');k.nodes.handle.style.left=0;k.nodes.handle.style.width='100%';W();k.nodes.slider.addEventListener('mousedown',X);}function W(){var a=window.getComputedStyle(k.nodes.handle).width;var o=k.sizes.width;k.sizes.handleWidth=parseInt(a);k.sizes.width=k.nodes.slider.offsetWidth;if(k.sizes.width!==k.sizes.handleWidth){c1(o);}a1();}function X(e){var a=e.target.id;var b=g+(k.sizes.handleWidth/2);var i=Math.max(e.clientX-b,0);var o=k.sizes.width-k.sizes.handleWidth;var e1=Math.min(i,o);if(a===k.nodes.slider.id){k.nodes.handle.style.left=e1+'px';k.drag.handleOffsetLeft=k.nodes.handle.offsetLeft;k.drag.isResize=false;}else if(a===k.nodes.handle.id){k.drag.handleClickOffsetX=e.offsetX;k.drag.isResize=false;}else if(a===k.nodes.leftResizeHandle.id){k.drag.whichResizeHandle=k.consts.LEFT_HANDLE_ID;k.drag.isResize=true;}else if(a===k.nodes.rightResizeHandle.id){k.drag.whichResizeHandle=k.consts.RIGHT_HANDLE_ID;k.drag.isResize=true;}else{return;}window.addEventListener('mousemove',Y);window.addEventListener('mouseup',$);}function Y(e){e.stopImmediatePropagation();var a;var b=e.clientX-g;if(k.drag.isResize){b1(e);return;}var i=k.sizes.width-k.sizes.handleWidth+k.drag.handleClickOffsetX;a=Math.max(Math.min(b,i),k.drag.handleClickOffsetX);k.nodes.handle.style.left=a-k.drag.handleClickOffsetX+'px';}function Z(e){var o=0;var a=37;var b=39;var i=5;if(e.keyCode!=a&&e.keyCode!=b){return;}else if(e.keyCode==a){o=-i;}else if(e.keyCode==b){o=i;}var e1=Math.min((k.drag.handleOffsetLeft+o),k.sizes.width-k.sizes.handleWidth);k.drag.handleOffsetLeft=Math.max(e1,0);k.nodes.handle.style.left=k.drag.handleOffsetLeft+'px';d1();B();}function $(e){e.stopImmediatePropagation();window.removeEventListener('mousemove',Y);window.removeEventListener('mouseup',$);a1();}function a1(){var a=window.getComputedStyle(k.nodes.handle).width;k.sizes.handleWidth=parseInt(a);k.drag.handleOffsetLeft=k.nodes.handle.offsetLeft;var b='(Double click to expand)';k.nodes.slider.setAttribute('title',b);d1();B();}function b1(e){e.stopImmediatePropagation();var a;var b;var i;var o;var e1;var f1;var g1=e.clientX-g;var h1=9;if(k.drag.whichResizeHandle===k.consts.RIGHT_HANDLE_ID){o=g1-k.drag.handleOffsetLeft;a=Math.max(o,k.sizes.handleMinWidth);b=k.sizes.width-k.drag.handleOffsetLeft;i=Math.min(a,b);k.nodes.handle.style.width=i+'px';}if(k.drag.whichResizeHandle===k.consts.LEFT_HANDLE_ID){a=k.drag.handleOffsetLeft+k.sizes.handleWidth-k.sizes.handleMinWidth;g1=Math.max(Math.min(g1,a),0);b=k.drag.handleOffsetLeft+k.sizes.handleWidth;e1=Math.min(g1,k.sizes.width);f1=Math.max(Math.max(e1,-2*k.sizes.handleMinWidth),h1);i=b-f1+9;if(i<=h1+k.sizes.handleMinWidth){i-=h1;f1+=h1;}k.nodes.handle.style.left=(f1-h1)+'px';k.nodes.handle.style.width=i+'px';}}function c1(o){var a=k.sizes.width-o;var b=k.sizes.width-k.drag.handleOffsetLeft;var e=k.sizes.handleWidth+a;k.sizes.handleWidth=Math.max(k.sizes.handleMinWidth,Math.min(e,b));k.nodes.handle.style.width=k.sizes.handleWidth+'px';if(k.sizes.width<(k.drag.handleOffsetLeft+k.sizes.handleWidth)){k.drag.handleOffsetLeft=k.sizes.width-k.sizes.handleWidth;k.nodes.handle.style.left=k.drag.handleOffsetLeft+'px';}}function d1(){if(!_.length){return;}var a=(k.drag.handleOffsetLeft/k.sizes.width)*100;var b=a+(k.sizes.handleWidth/k.sizes.width)*100;var e=_[_.length-1].end/100;k.selectedInterval.start=(a*e).toFixed(0);k.selectedInterval.end=(b*e).toFixed(0);}return l;});
