/*
 * ! OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/merge","sap/base/util/ObjectPath","sap/ui/core/Component","sap/ui/fl/initial/_internal/StorageUtils","sap/ui/fl/apply/_internal/flexState/Loader","sap/ui/fl/apply/_internal/flexState/ManifestUtils","sap/ui/fl/apply/_internal/flexState/prepareAppDescriptorMap","sap/ui/fl/apply/_internal/flexState/prepareChangesMap","sap/ui/fl/apply/_internal/flexState/prepareVariantsMap","sap/ui/fl/LayerUtils","sap/ui/fl/Utils","sap/base/Log"],function(m,O,C,S,L,M,p,a,b,c,U,d){"use strict";var F={};var _={};var e={};var f={};var g={appDescriptorMap:p,changesMap:a,variantsMap:b};function h(P){var y=C.get(P.componentId);_[P.reference].componentData=y?y.getComponentData():P.componentData;}function i(P){var y=C.get(P.componentId);P.componentData=P.componentData||y.getComponentData()||{};P.manifest=P.manifest||P.rawManifest||y.getManifestObject();P.reference=P.reference||M.getFlexReference(P);}function j(R,y){if(!_[R]){throw new Error("State is not yet initialized");}if(!_[R].preparedMaps[y]){var P={unfilteredStorageResponse:_[R].unfilteredStorageResponse,storageResponse:_[R].storageResponse,componentId:_[R].componentId,componentData:_[R].componentData};_[R].preparedMaps[y]=F._callPrepareFunction(y,P);}return _[R].preparedMaps[y];}function k(R){return j(R,"appDescriptorMap");}function l(R){return j(R,"changesMap");}function n(R){return j(R,"variantsMap");}function o(P){if(P.reference.endsWith(".Component")){var y=P.reference.split(".");y.pop();var R=y.join(".");_[R]=m({},{storageResponse:{changes:S.getEmptyFlexDataResponse()},unfilteredStorageResponse:{changes:S.getEmptyFlexDataResponse()},preparedMaps:{},componentId:P.componentId,partialFlexState:P.partialFlexState});f[R]=f[P.reference];}}function q(R){var y=m({},R);var z=y.changes;var A=["changes","variants","variantChanges","variantDependentControlChanges","variantManagementChanges"];if(c.isLayerFilteringRequired()){A.forEach(function(T){z[T]=c.filterChangeDefinitionsByMaxLayer(z[T]);});}return y;}function r(P){f[P.reference]=L.loadFlexData(P).then(function(R){_[P.reference]=m({},{unfilteredStorageResponse:R,preparedMaps:{},componentId:P.componentId,componentData:P.componentData,partialFlexState:P.partialFlexState});o(P);s(P.reference);return R;});return f[P.reference];}function s(R){U.ifUShellContainerThen(function(y){e[R]=u.bind(null,R);y[0].registerNavigationFilter(e[R]);},["ShellNavigation"]);}function t(R){U.ifUShellContainerThen(function(y){if(e[R]){y[0].unregisterNavigationFilter(e[R]);delete e[R];}},["ShellNavigation"]);}function u(R,N,y){return U.ifUShellContainerThen(function(z){try{var A=c.getMaxLayerTechnicalParameter(N);var P=c.getMaxLayerTechnicalParameter(y);if(A!==P){F.clearFilteredResponse(R);}}catch(E){d.error(E.message);}return z[0].NavigationFilterStatus.Continue;},["ShellNavigation"]);}function v(R){_[R].preparedMaps={};}function w(I){var y=_[I.reference];if(y.partialFlexState===true&&I.partialFlexState!==true){y.partialFlexState=false;I.partialFlexData=m({},y.unfilteredStorageResponse.changes);I.reInitialize=true;}return I;}function x(I){var y=_[I.reference].componentId;if(!I.reInitialize&&y!==I.componentId){I.reInitialize=true;}return I;}F.initialize=function(P){return Promise.resolve(P).then(function(I){i(I);var y=I.reference;if(f[y]){return f[y].then(w.bind(null,I)).then(x).then(function(E){return E.reInitialize?r(E):_[y].unfilteredStorageResponse;});}return r(I);}).then(function(P,R){if(!_[P.reference].storageResponse){_[P.reference].storageResponse=q(R);h(P);F.getVariantsState(P.reference);}}.bind(null,P));};F.clearAndInitialize=function(P){i(P);var V=!!O.get(["preparedMaps","variantsMap"],_[P.reference]);F.clearState(P.reference);F.clearState(U.normalizeReference(P.reference));return F.initialize(P).then(function(V,R){if(V){return F.getVariantsState(R);}}.bind(null,V,P.reference));};F.clearState=function(R){if(R){t(R);delete _[R];delete f[R];}else{Object.keys(_).forEach(function(R){t(R);});_={};f={};}};F.clearFilteredResponse=function(R){if(_[R]){v(R);delete _[R].storageResponse;}};F.getUIChanges=function(R){return l(R).changes;};F.getAppDescriptorChanges=function(R){return k(R).appDescriptorChanges;};F.getVariantsState=function(R){return n(R);};F.getUI2Personalization=function(R){return _[R].unfilteredStorageResponse.changes.ui2personalization;};F._callPrepareFunction=function(y,P){return g[y](P);};F.getStorageResponse=function(R){if(f[R]){return f[R].then(function(){return _[R].unfilteredStorageResponse;});}};F.getFlexObjectsFromStorageResponse=function(R){return _[R]&&_[R].unfilteredStorageResponse.changes;};return F;},true);
