/*
 * ! OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/fl/Utils","sap/base/util/ObjectPath","sap/base/Log","sap/ui/fl/Change","sap/base/util/includes","sap/ui/fl/apply/_internal/controlVariants/Utils","sap/base/util/isEmptyObject","sap/base/util/each","sap/base/util/values","sap/base/util/merge","sap/ui/core/Component","sap/ui/fl/LayerUtils"],function(U,O,L,C,i,V,a,e,v,m,b,c){"use strict";function d(A,B){var D=m({},A);B.forEach(function(E){D[E.fileName]={content:E,controlChanges:[],variantChanges:{}};});return D;}function f(A,B){var D=m({},A);B.forEach(function(E){D[E.variantReference]=D[E.variantReference]||t(E.variantReference);D[E.variantReference].controlChanges.push(E);});return D;}function g(A,B){var D=m({},A);B.forEach(function(E){D[E.selector.id]=D[E.selector.id]||t(E.selector.id);var F=D[E.selector.id].variantChanges[E.changeType]||[];F.push(E);D[E.selector.id].variantChanges[E.changeType]=F;});return D;}function h(A){var B=m({},A);v(A).forEach(function(D){var S=O.get("variantChanges.setVisible",D);if(S&&S.length>0){var E=x(S);if(!E.getContent().visible&&E.getContent().createdByReset){delete B[D.content.fileName];}}});return B;}function r(A){var B=m({},A);v(B).forEach(function(D){var E=D.content.variantReference;var R;if(E){R=k(B,E,D.content.variantManagementReference);}D.controlChanges=j(R,D.content.layer).concat(D.controlChanges);});return B;}function j(R,A){if(!R){return[];}return v(m({},R.controlChanges)).filter(function(B){return c.compareAgainstCurrentLayer(B.layer,A)===-1;});}function k(A,B,D){var R=A[B];if(!R&&B===D){R=t(B);A[B]=R;}return R;}function l(S){var A={};A=d(A,S.variants);A=f(A,S.variantDependentControlChanges);A=g(A,S.variantChanges);A=h(A);A=r(A);return A;}function n(){return{variantManagementChanges:{},variants:[]};}function o(R,A,T){var B=m({},R);v(A).forEach(function(D){var E=D.content.variantManagementReference;if(!B[E]){B[E]=n();}D=z(D);D=w(D);if(!B[E].currentVariant&&D.content.content.visible&&i(T,D.content.fileName)){B[E].currentVariant=D.content.fileName;}B[E].defaultVariant=E;var S=V.getIndexToSortVariant(B[E].variants,D);B[E].variants.splice(S,0,D);});return B;}function p(R,A){var B=m({},R);A.forEach(function(D){var E=D.selector.id;if(!B[E]){B[E]=n();}var F=D.changeType;if(!B[E].variantManagementChanges[F]){B[E].variantManagementChanges[F]=[];}B[E].variantManagementChanges[F].push(D);B[E]=u(B[E]);});return B;}function q(R){var A=m({},R);e(A,function(B,D){var S=D.variants.findIndex(function(F){return F.content.fileName===B;});var E;if(S===-1){E=t(B);}else{E=D.variants[S];D.variants.splice(S,1);}D.variants.unshift(E);});return A;}function s(A,B,T){var R={};R=o(R,A,T);R=p(R,B);R=q(R);return R;}function t(A){var R=sap.ui.getCore().getLibraryResourceBundle("sap.ui.fl");return{content:{fileName:A,variantManagementReference:A,content:{title:R.getText("STANDARD_VARIANT_TITLE"),favorite:true,visible:true},support:{user:V.DEFAULT_AUTHOR}},variantChanges:{},controlChanges:[]};}function u(A){var B=m({},A);var D=B.variantManagementChanges;var E;if(!a(D)){E=x(D["setDefault"]);if(E){B.defaultVariant=E.getContent().defaultVariant;}}return B;}function w(A){var B=m({},A);var D=B.variantChanges;var E;e(D,function(F,G){switch(F){case"setTitle":E=x(G);if(E){B.content.content.title=E.getText("title");}break;case"setFavorite":E=x(G);if(E){B.content.content.favorite=E.getContent().favorite;}break;case"setExecuteOnSelect":E=x(G);if(E){B.content.content.executeOnSelect=E.getContent().executeOnSelect;}break;case"setVisible":E=x(G);if(E){B.content.content.visible=E.getContent().visible;}break;default:L.error("No valid changes on variant "+B.content.content.title+" available");}});return B;}function x(A){if(A.length>0){return new C(A[A.length-1]);}return false;}function y(T){return sap.ui.getCore().getLibraryResourceBundle("sap.ui.fl").getText(T);}function z(A){var B=m({},A);if(B.content.fileName===B.content.variantManagementReference){if(!O.get("content.support.user",B)){var S={support:{user:V.DEFAULT_AUTHOR}};m(B.content,S);}}if(!B.content.content.favorite){B.content.content.favorite=true;}if(!B.content.content.visible){B.content.content.visible=true;}if(!B.content.content.executeOnSelect){B.content.content.executeOnSelect=false;}var T=B.content.content.title.match(/.i18n>(\w+)./);if(T){B.content.content.title=y(T[1]);}return B;}return function(P){if(a(P)||!O.get("storageResponse.changes.variants",P)){return{};}var T=O.get(["technicalParameters",V.VARIANT_TECHNICAL_PARAMETER],P.componentData)||[];var A=l(P.storageResponse.changes);A=s(A,P.storageResponse.changes.variantManagementChanges,T);return A;};});
