/*
 * ! OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/restricted/_omit","sap/base/util/each","sap/base/util/includes","sap/base/util/isEmptyObject","sap/base/util/merge","sap/base/util/ObjectPath","sap/base/Log","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/core/BusyIndicator","sap/ui/fl/apply/_internal/changes/Reverter","sap/ui/fl/apply/_internal/controlVariants/URLHandler","sap/ui/fl/apply/_internal/flexState/controlVariants/Switcher","sap/ui/fl/apply/_internal/flexState/controlVariants/VariantManagementState","sap/ui/fl/apply/_internal/controlVariants/Utils","sap/ui/fl/changeHandler/Base","sap/ui/fl/Change","sap/ui/fl/Layer","sap/ui/fl/LayerUtils","sap/ui/fl/Utils","sap/ui/model/json/JSONModel"],function(_,e,i,a,m,O,L,J,B,R,U,S,V,b,c,C,d,f,g,h){"use strict";function j(E,P){return n(function(t,v){var M=v.model;var u=v.vmReference;var x=false;var T=t.key;var y=t.key;return Promise.resolve().then(function(){if(O.get([u,"currentVariant"],M.oData)&&M.oData[u].currentVariant!==M.oData[u].originalCurrentVariant){y=M.oData[u].originalCurrentVariant;x=true;return M.updateCurrentVariant(u,T,M.oAppComponent,true);}}).then(function(){if(O.get([u,"modified"],M.oData)===true){var z=V.getControlChangesForVariant({reference:M.sFlexReference,vmReference:u,vReference:y,changeInstance:true});return k({changes:z,vmReference:u,vReference:y,revert:!x,model:M}).then(function(){M.oData[u].originalCurrentVariant=T;M.oData[u].modified=false;M.checkUpdate(true);});}}).then(function(){if(!x){M._callVariantSwitchListeners(u,M.oData[u].currentVariant);}});}.bind(null,E.getParameters(),P),P.model,P.vmReference);}function k(P){var v=P.model._getDirtyChangesFromVariantChanges(P.changes);return Promise.resolve().then(function(){if(P.revert){return R.revertMultipleChanges(v,{appComponent:P.model.oAppComponent,modifier:J,flexController:P.model.oFlexController});}}).then(function(){v.forEach(function(t){V.removeChangeFromVariant({reference:P.model.sFlexReference,change:t,vmReference:P.vmReference,vReference:P.vReference});P.model.oFlexController.deleteChange(t,P.model.oAppComponent);});});}function l(M,v,t){if(t||M.oData[v]){M.oData[v].variantBusy=t;}M.checkUpdate();}function n(t,M,v){M._oVariantSwitchPromise=M._oVariantSwitchPromise.catch(function(){}).then(l.bind(null,M,v,true)).then(t).then(l.bind(null,M,v,false)).catch(function(E){l(M,v,false);throw E;});M.oFlexController.setVariantSwitchPromise(M._oVariantSwitchPromise);return M._oVariantSwitchPromise;}function r(P){return S.switchVariant(P).then(function(){delete this.oData[P.vmReference];}.bind(this)).catch(function(E){L.warning(E.message);});}function s(P){return S.switchVariant(P).then(function(){this.oData[P.vmReference].originalCurrentVariant=P.newVReference;this.oData[P.vmReference].currentVariant=P.newVReference;if(this.oData[P.vmReference].updateVariantInURL){U.updateVariantInURL({vmReference:P.vmReference,newVReference:P.newVReference,model:this});}this._callVariantSwitchListeners(P.vmReference,P.newVReference);this.checkUpdate();}.bind(this));}function o(v,t,D){if((v.layer===f.getCurrentLayer(!D))&&(v.key!==t)){return true;}return false;}function w(t){return new Promise(function(u){if(t.getDomRef()){u();}else{t.addEventDelegate({onAfterRendering:function(){u();}});}});}var p=h.extend("sap.ui.fl.variants.VariantModel",{constructor:function(D,F,A,t){this.pSequentialImportCompleted=Promise.resolve();h.apply(this,arguments);this.bObserve=t;if(!F){F=sap.ui.requireSync("sap/ui/fl/FlexControllerFactory").createForControl(A);}this.oFlexController=F;this.oChangePersistence=this.oFlexController._oChangePersistence;this.sFlexReference=this.oChangePersistence.getComponentName();this.oAppComponent=A;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.fl");this._oVariantSwitchPromise=Promise.resolve();this._oVariantAppliedListeners={};if(a(D)){try{D=V.fillVariantModel({reference:this.sFlexReference});}catch(E){L.error("Variants Map was not found: "+E.message);}}if(D&&typeof D==="object"){Object.keys(D).forEach(function(K){D[K].variants.forEach(function(v){if(!D[K].currentVariant&&(v.key===D[K].defaultVariant)){D[K].currentVariant=v.key;}v.originalTitle=v.title;v.originalFavorite=v.favorite;v.originalExecuteOnSelect=v.executeOnSelect;v.originalVisible=v.visible;});D[K].originalCurrentVariant=D[K].currentVariant;D[K].originalDefaultVariant=D[K].defaultVariant;});this.setData(D);}U.initialize({model:this});}});p.prototype.updateCurrentVariant=function(v,N,A,I){var P={vmReference:v,currentVReference:this.oData[v].originalCurrentVariant,newVReference:N,flexController:this.oFlexController,appComponent:A||this.oAppComponent,modifier:J,reference:this.sFlexReference};if(I){return s.call(this,P);}return n(s.bind(this,P),this,v);};p.prototype.getCurrentVariantReference=function(v){return this.oData[v].currentVariant;};p.prototype.getVariantManagementReference=function(v){var t="";var I=-1;Object.keys(this.oData).some(function(K){return this.oData[K].variants.some(function(u,x){if(u.key===v){t=K;I=x;return true;}});}.bind(this));return{variantManagementReference:t,variantIndex:I};};p.prototype.getVariant=function(v,t){return V.getVariant({reference:this.sFlexReference,vmReference:t||this.getVariantManagementReference(v).variantManagementReference,vReference:v});};p.prototype.getVariantProperty=function(v,P){return this.getVariant(v).content.content[P];};function q(v){var t=V.getVariantChangesForVariant({vmReference:v,reference:this.sFlexReference});var u=this.oData[v].currentVariant;var D=this.oData[v].defaultVariant;if(this.oData[v]._executeOnSelectionForStandardDefault&&u===D&&u===v&&!t.setExecuteOnSelect){var x=V.getVariant({reference:this.sFlexReference,vmReference:v,vReference:v});x.content.content.executeOnSelect=true;this.oData[v].variants[0].originalExecuteOnSelect=true;this.oData[v].variants[0].executeOnSelect=true;return true;}}p.prototype.attachVariantApplied=function(P){var v=this.getVariantManagementReferenceForControl(sap.ui.getCore().byId(P.vmControlId));return this.waitForVMControlInit(v).then(function(v,P){if(!this._oVariantAppliedListeners[v]){this._oVariantAppliedListeners[v]={};}var I=q.call(this,v);if(P.callAfterInitialVariant||I){var t={appComponent:this.oAppComponent,reference:this.sFlexReference,vmReference:v,flexController:this.oFlexController};V.waitForInitialVariantChanges(t).then(function(){var u=V.getCurrentVariantReference({vmReference:v,reference:this.sFlexReference});this._callVariantSwitchListeners(v,u,P.callback);}.bind(this));}return w(P.control).then(function(){if(b.getRelevantVariantManagementControlId(P.control,this.getVariantManagementControlIds())===P.vmControlId){this.oData[v].showExecuteOnSelection=true;this.checkUpdate(true);this._oVariantAppliedListeners[v][P.control.getId()]=P.callback;}else{L.error("Error in attachVariantApplied: The passed VariantManagement ID does not match the responsible VariantManagement control");}}.bind(this));}.bind(this,v,P));};p.prototype._callVariantSwitchListeners=function(v,N,t){if(this._oVariantAppliedListeners[v]){var u;this.oData[v].variants.some(function(x){if(x.key===N){u=x;return true;}});if(t){t(u);}else{e(this._oVariantAppliedListeners[v],function(x,t){t(u);});}}};p.prototype.detachVariantApplied=function(v,t){var u=this.getVariantManagementReferenceForControl(sap.ui.getCore().byId(v));if(this._oVariantAppliedListeners[u]){delete this._oVariantAppliedListeners[u][t];}};p.prototype.addChange=function(t){var v=t.getVariantReference();var u=this.getVariantManagementReference(v).variantManagementReference;this.oData[u].modified=!!this.oData[u].variantsEditable;this.checkUpdate(true);return V.addChangeToVariant({reference:this.sFlexReference,change:t,vmReference:u,vReference:v});};p.prototype.removeChange=function(t){var v=t.getVariantReference();var u=this.getVariantManagementReference(v).variantManagementReference;return V.removeChangeFromVariant({reference:this.sFlexReference,change:t,vmReference:u,vReference:v});};p.prototype._getVariantTitleCount=function(N,v){var D=this.getData();return D[v].variants.reduce(function(t,u){if(N.toLowerCase()===u.title.toLowerCase()&&u.visible){t++;}return t;},0);};p.prototype._duplicateVariant=function(P){var N=P.newVariantReference;var t=P.sourceVariantReference;var v=P.variantManagementReference;var u=this.getVariant(t);var x=V.getControlChangesForVariant({vmReference:v,vReference:t,changeInstance:true,reference:this.sFlexReference}).map(function(E){return E.getDefinition();});var D={content:{},controlChanges:x,variantChanges:{}};var y=f.compareAgainstCurrentLayer(u.content.layer,!this._bDesignTimeMode?d.USER:"");Object.keys(u.content).forEach(function(K){if(K==="fileName"){D.content[K]=N;}else if(K==="variantReference"){if(y===0){D.content[K]=u.content["variantReference"];}else if(y===-1){D.content[K]=t;}}else if(K==="content"){D.content[K]=JSON.parse(JSON.stringify(u.content[K]));D.content.content.title=P.title;}else{D.content[K]=u.content[K];}});D.content["layer"]=P.layer;x=D.controlChanges.slice();var z={};var A;D.controlChanges=x.reduce(function(E,F){if(f.compareAgainstCurrentLayer(F.layer,!this._bDesignTimeMode?d.USER:"")===0){z=m({},F);z.variantReference=D.content.fileName;if(!z.support){z.support={};}z.support.sourceChangeFileName=F.fileName;z.packageName="$TMP";A=C.createInitialFileContent(z);E.push(new C(A));}return E;}.bind(this),[]);return D;};p.prototype.copyVariant=function(P){var D=this._duplicateVariant(P);var v={key:D.content.fileName,layer:P.layer,title:D.content.content.title,originalTitle:D.content.content.title,originalExecuteOnSelect:D.content.content.executeOnSelect,executeOnSelect:false,favorite:true,originalFavorite:true,rename:true,change:true,remove:true,visible:true,originalVisible:true};var t=b.createVariant({appVersion:this.oFlexController.getAppVersion(),model:this,variantSpecificData:D});var u=[];[t].concat(t.getControlChanges()).forEach(function(x){u.push(this.oChangePersistence.addDirtyChange(x));}.bind(this));var I=V.addVariantToVariantManagement({variantData:m({},t.getDefinitionWithChanges(),{content:{content:{visible:v.visible,favorite:v.favorite}}}),reference:this.sFlexReference,vmReference:P.variantManagementReference});this.oData[P.variantManagementReference].variants.splice(I,0,v);return this.updateCurrentVariant(P.variantManagementReference,t.getId(),P.appComponent,true).then(function(){return u;});};p.prototype.removeVariant=function(P){var t=this.oChangePersistence.getDirtyChanges().filter(function(u){return(u.getVariantReference&&u.getVariantReference()===P.variant.getId())||u.getId()===P.variant.getId();});return this.updateCurrentVariant(P.variantManagementReference,P.sourceVariantReference,P.component).then(function(){var I=V.removeVariantFromVariantManagement({reference:this.sFlexReference,variant:P.variant,vmReference:P.variantManagementReference});this.oData[P.variantManagementReference].variants.splice(I,1);this.checkUpdate();t.forEach(function(u){this.oChangePersistence.deleteChange(u);}.bind(this));}.bind(this));};p.prototype.collectModelChanges=function(v,t){var D=this.getData()[v];var M=D.variants;var u=[];var P={};M.forEach(function(x){if(x.originalTitle!==x.title){P={variantReference:x.key,changeType:"setTitle",title:x.title,originalTitle:x.originalTitle,layer:t};u.push(P);}if(x.originalFavorite!==x.favorite){P={variantReference:x.key,changeType:"setFavorite",favorite:x.favorite,originalFavorite:x.originalFavorite,layer:t};u.push(P);}if(x.originalExecuteOnSelect!==x.executeOnSelect){P={variantReference:x.key,changeType:"setExecuteOnSelect",executeOnSelect:x.executeOnSelect,originalExecuteOnSelect:x.originalExecuteOnSelect,layer:t};u.push(P);}if(!x.visible&&x.originalVisible){P={variantReference:x.key,changeType:"setVisible",visible:false,layer:t};u.push(P);}});if(D.originalDefaultVariant!==D.defaultVariant){P={variantManagementReference:v,changeType:"setDefault",defaultVariant:D.defaultVariant,originalDefaultVariant:D.originalDefaultVariant,layer:t};u.push(P);}return u;};p.prototype.manageVariants=function(v,t,u,x){return new Promise(function(y){v.attachEventOnce("manage",{resolve:y,variantManagementReference:t,layer:u},this.fnManageClickRta,this);v.openManagementDialog(true,x);}.bind(this));};p.prototype.setVariantProperties=function(v,P,A){var t=-1;var u;var x=null;var D=this.getData();if(P.variantReference){t=this.getVariantManagementReference(P.variantReference).variantIndex;u=D[v].variants[t];}var N={};var y={};switch(P.changeType){case"setTitle":y.title=P.title;u.title=P.title;u.originalTitle=u.title;break;case"setFavorite":y.favorite=P.favorite;u.favorite=P.favorite;u.originalFavorite=u.favorite;break;case"setExecuteOnSelect":y.executeOnSelect=P.executeOnSelect;if(u){u.executeOnSelect=P.executeOnSelect;u.originalExecuteOnSelect=u.executeOnSelect;}break;case"setVisible":y.visible=P.visible;y.createdByReset=false;u.visible=P.visible;u.originalVisible=u.visible;break;case"setDefault":y.defaultVariant=P.defaultVariant;D[v].defaultVariant=P.defaultVariant;D[v].originalDefaultVariant=D[v].defaultVariant;var H=U.getStoredHashParams({model:this});if(H){if(D[v].defaultVariant!==D[v].currentVariant&&H.indexOf(D[v].currentVariant)===-1){U.update({parameters:H.concat(D[v].currentVariant),updateURL:!this._bDesignTimeMode,updateHashEntry:true,model:this});}else if(D[v].defaultVariant===D[v].currentVariant&&H.indexOf(D[v].currentVariant)>-1){H.splice(H.indexOf(D[v].currentVariant),1);U.update({parameters:H,updateURL:!this._bDesignTimeMode,updateHashEntry:true,model:this});}}if(!A&&D[v].currentVariant!==P.defaultVariant){this.updateCurrentVariant(v,P.defaultVariant,P.appComponent);}break;default:break;}var z=V.getContent(this.sFlexReference);if(t>-1){var E=V.setVariantData({variantData:y,vmReference:v,previousIndex:t,reference:this.sFlexReference});D[v].variants.splice(t,1);D[v].variants.splice(E,0,u);}else if(z[v]){z[v].defaultVariant=P.defaultVariant;}var F={vmReference:v,add:A,reference:this.sFlexReference};if(A===true){N.changeType=P.changeType;N.layer=P.layer;if(P.changeType==="setDefault"){N.fileType="ctrl_variant_management_change";N.selector=J.getSelector(v,P.appComponent);}else{if(P.changeType==="setTitle"){c.setTextInChange(N,"title",P.title,"XFLD");}N.fileType="ctrl_variant_change";N.selector=J.getSelector(P.variantReference,P.appComponent);}x=this.oFlexController.createBaseChange(N,P.appComponent);x.setContent(y);F.changeContent=x.getDefinition();V.updateChangesForVariantManagementInMap(F);this.oChangePersistence.addDirtyChange(x);}else if(P.change){F.changeContent=P.change.getDefinition();V.updateChangesForVariantManagementInMap(F);this.oChangePersistence.deleteChange(P.change);}this.setData(D);this.checkUpdate(true);return x;};p.prototype._ensureStandardVariantExists=function(v){var D=this.getData();var t=D[v]||{};var u=_(t,["initPromise"]);if(!D[v]||a(u)){D[v]=m(t,{currentVariant:v,originalCurrentVariant:v,defaultVariant:v,originalDefaultVariant:v,variants:[{key:v,title:this._oResourceBundle.getText("STANDARD_VARIANT_TITLE"),originalTitle:this._oResourceBundle.getText("STANDARD_VARIANT_ORIGINAL_TITLE"),favorite:true,originalFavorite:true,executeOnSelect:false,originalExecuteOnSelect:false,visible:true,originalVisible:true,author:b.DEFAULT_AUTHOR}]});this.setData(D);var x={};x[v]={defaultVariant:v,variantManagementChanges:{},variants:[{content:{fileName:v,fileType:"ctrl_variant",variantManagementReference:v,variantReference:"",support:{user:b.DEFAULT_AUTHOR},content:{title:this._oResourceBundle.getText("STANDARD_VARIANT_TITLE"),favorite:true,visible:true,executeOnSelect:false}},controlChanges:[],variantChanges:{}}]};try{var y=V.getContent(this.sFlexReference);m(y,x);}catch(E){L.error("Variants Map was not found: "+E.message);}}};p.prototype.setModelPropertiesForControl=function(v,D,t){this.oData[v].modified=false;this.oData[v].showFavorites=true;var u=this._bDesignTimeMode;if(u!==D){this._bDesignTimeMode=D;if(D){U.clearAllVariantURLParameters({model:this});}else if(u){U.update({parameters:U.getStoredHashParams({model:this}),updateURL:true,updateHashEntry:false,model:this});}}if(!(typeof this.fnManageClick==="function"&&typeof this.fnManageClickRta==="function")){this._initializeManageVariantsEvents();}t.detachManage(this.fnManageClick,this);if(D){this.oData[v].variantsEditable=false;this.oData[v].variants.forEach(function(x){x.rename=true;x.change=true;x.remove=o(x,v,D);});}else if(this.oData[v]._isEditable){t.attachManage({variantManagementReference:v},this.fnManageClick,this);this.oData[v].variantsEditable=true;this.oData[v].variants.forEach(function(x){x.remove=o(x,v,D);if(x.layer===f.getCurrentLayer(true)){x.rename=true;x.change=true;}else{x.rename=false;x.change=false;}});}else{this.oData[v].variantsEditable=false;this.oData[v].variants.forEach(function(x){x.remove=false;x.rename=false;x.change=false;});}};p.prototype._initializeManageVariantsEvents=function(){this.fnManageClickRta=function(E,D){var t=this.collectModelChanges(D.variantManagementReference,D.layer);D.resolve(t);};this.fnManageClick=function(E,D){if(!this.oFlexController||!V.getContent(this.sFlexReference)){return;}var t=this.collectModelChanges(D.variantManagementReference,f.getCurrentLayer(true));var u=[];t.forEach(function(v){v.appComponent=this.oAppComponent;u.push(this.setVariantProperties(D.variantManagementReference,v,true));}.bind(this));this.oChangePersistence.saveDirtyChanges(this.oAppComponent,false,u);};};p.prototype._handleSave=function(E){var v=E.getSource();var A=g.getAppComponentForControl(v);var t=this.getLocalId(v.getId(),A);return n(function(u,A,P){var x=P.def;var y=P.execute;var z=this.getCurrentVariantReference(u);var D=V.getControlChangesForVariant({reference:this.sFlexReference,vmReference:u,vReference:z,changeInstance:true});if(P["overwrite"]){return this.oFlexController.saveSequenceOfDirtyChanges(this._getDirtyChangesFromVariantChanges(D),A).then(function(G){this.checkDirtyStateForControlModels([u]);return G;}.bind(this));}var N=g.createDefaultFileName();var F={variantManagementReference:u,appComponent:A,layer:f.getCurrentLayer(true),title:P["name"],sourceVariantReference:z,newVariantReference:N};return this.copyVariant(F).then(function(G){if(x){var H={changeType:"setDefault",defaultVariant:N,originalDefaultVariant:this.oData[u].defaultVariant,appComponent:A,layer:f.getCurrentLayer(true),variantManagementReference:u};var I=this.setVariantProperties(u,H,true);G.push(I);}if(y){var K={changeType:"setExecuteOnSelect",executeOnSelect:true,variantReference:N,appComponent:A,layer:f.getCurrentLayer(true),variantManagementReference:u};var M=this.setVariantProperties(u,K,true);G.push(M);}this.oData[u].modified=false;this.checkUpdate(true);return k({changes:D,vmReference:u,vReference:z,model:this}).then(this.oFlexController.saveSequenceOfDirtyChanges.bind(this.oFlexController,G,A));}.bind(this));}.bind(this,t,A,E.getParameters()),this,t);};p.prototype.getLocalId=function(I,A){return J.getSelector(I,A).id;};p.prototype.getVariantManagementReferenceForControl=function(v){var t=v.getId();var A=g.getAppComponentForControl(v);return(A&&A.getLocalId(t))||t;};p.prototype.switchToDefaultForVariantManagement=function(v){if(this.oData[v].currentVariant!==this.oData[v].defaultVariant){B.show(200);this.updateCurrentVariant(v,this.oData[v].defaultVariant).then(function(){B.hide();});}};p.prototype.switchToDefaultForVariant=function(v){Object.keys(this.oData).forEach(function(t){if(!v||this.oData[t].currentVariant===v){this.switchToDefaultForVariantManagement(t);}}.bind(this));};p.prototype.registerToModel=function(v){var t=this.getVariantManagementReferenceForControl(v);this._ensureStandardVariantExists(t);this.oData[t]._isEditable=v.getEditable();this.oData[t]._executeOnSelectionForStandardDefault=v.getExecuteOnSelectionForStandardDefault();this.oData[t].showExecuteOnSelection=false;v.attachEvent("select",{vmReference:t,model:this},j);v.attachSave(this._handleSave,this);this.setModelPropertiesForControl(t,false,v);var u=v.getUpdateVariantInURL();this.oData[t].updateVariantInURL=u;U.registerControl({vmReference:t,updateURL:!!u,model:this});U.handleModelContextChange({model:this,vmControl:v});if(this.oData[t].initPromise){this.oData[t].initPromise.resolveFunction();delete this.oData[t].initPromise;}this.oData[t].init=true;};p.prototype.waitForVMControlInit=function(v){if(!this.oData[v]){this.oData[v]={};}else if(this.oData[v].init){return Promise.resolve();}this.oData[v].initPromise={};this.oData[v].initPromise.promise=new Promise(function(t){this.oData[v].initPromise.resolveFunction=t;}.bind(this));return this.oData[v].initPromise.promise;};p.prototype._getDirtyChangesFromVariantChanges=function(t){var u=t.map(function(v){return v.getDefinition().fileName;});return this.oChangePersistence.getDirtyChanges().filter(function(v){return i(u,v.getId());});};p.prototype.checkDirtyStateForControlModels=function(v){v.forEach(function(t){var u=this.oData[t];if(u.modified===true){var x=this.getCurrentVariantReference(t);var y=V.getControlChangesForVariant({reference:this.sFlexReference,vmReference:t,vReference:x,changeInstance:true});var D=this._getDirtyChangesFromVariantChanges(y);if(D.length===0){u.modified=false;}}}.bind(this));this.checkUpdate(true);};p.prototype.getCurrentControlVariantIds=function(){return Object.keys(this.oData||{}).reduce(function(t,v){return t.concat([this.oData[v].currentVariant]);}.bind(this),[]);};p.prototype.getVariantManagementControlIds=function(){var v;return Object.keys(this.oData||{}).reduce(function(t,u){if(this.oAppComponent.byId(u)){v=this.oAppComponent.createId(u);}else{v=u;}t.push(v);return t;}.bind(this),[]);};p.prototype.resetMap=function(){var v=Object.keys(this.oData);v.forEach(function(t){var P={vmReference:t,currentVReference:this.oData[t].currentVariant||this.oData[t].defaultVariant,newVReference:true,appComponent:this.oAppComponent,flexController:this.oFlexController,modifier:J,reference:this.sFlexReference};return n(r.bind(this,P),this,t);}.bind(this));return this._oVariantSwitchPromise.then(function(){V.resetContent(this.sFlexReference);U.initialize({model:this});U.update({parameters:[],updateHashEntry:true,model:this});}.bind(this));};return p;},true);
