/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/test/_OpaLogger","sap/ui/test/_ParameterValidator","sap/ui/test/autowaiter/_utils","sap/ui/thirdparty/jquery"],function(_,a,b,q){"use strict";var l=_.getLogger("sap.ui.test.autowaiter._timeoutWaiter");var h=_.getLogger("sap.ui.test.autowaiter._timeoutWaiter#hasPending");var c=new a({errorPrefix:"sap.ui.test.autowaiter._timeoutWaiter#extendConfig"});var t={};var d=1;var D=1000;var i=10;var e={maxDepth:d,maxDelay:D,minDelay:i};var f={TRACKED:"TRACKED",STARTER:"STARTED",FINISHED:"FINISHED",CLEARED:"CLEARED"};var I;function g(N){var s="set"+N;var C="clear"+N;var o=window[s];if(!o){return;}var O=window[C];window[s]=function wrappedSetTimeout(p,r,u){r=r||0;var v=Array.prototype.slice.call(arguments,2);var w={delay:r,initiator:I,func:b.functionToString(p),stack:b.resolveStackTrace(),status:f.TRACKED};var x;if(u&&u==='TIMEOUT_WAITER_IGNORE'){x=o.apply(null,[p,r].concat(v.slice(1)));l.trace("Timeout with ID "+x+" should not be tracked. "+" Delay: "+r+" Initiator: "+I);return x;}var W=function wrappedCallback(){var y=t[x];if(!y){l.trace("Timeout data for timeout with ID "+x+" disapered unexpectedly");y={};}I=x;l.trace("Timeout with ID "+x+" started");y.status=f.STARTED;try{p();}finally{I=undefined;}l.trace("Timeout with ID "+x+" finished");y.status=f.FINISHED;};x=o.apply(null,[W,r].concat(v));l.trace("Timeout with ID "+x+" is tracked. "+" Delay: "+r+" Initiator: "+I);t[x]=w;return x;};window[C]=function wrappedClearTimeout(p){if(!p){l.trace("Could not clean timeout with invalid ID: "+p);return;}var r=t[p];if(!r){l.trace("Timeout data for timeout with ID "+p+" disapered unexpectedly or timeout was not tracked intentionally");r={};}r.status=f.CLEARED;l.trace("Timeout with ID "+p+" cleared");O(p);};}g("Timeout");g("Immediate");function j(T,o,B,p){return"\nTimeout: ID: "+T+" Type: "+(B?"BLOCKING":"NOT BLOCKING")+" Status: "+o.status+" Delay: "+o.delay+" Initiator: "+o.initiator+(p?("\nFunction: "+o.func):"")+(p?("\nStack: "+o.stack):"");}function k(B){var T=Object.keys(t);var L="Found "+B.length+" blocking out of "+T.length+" tracked timeouts";B.forEach(function(o){L+=j(o,t[o],B.some(function(p){return p==o;}),true);});h.debug(L);var s="Tracked timeouts";T.forEach(function(o){s+=j(o,t[o],B.some(function(p){return p==o;}),true);});h.trace(s);}function m(o){var C=t[o];if(C.status!==f.TRACKED){return false;}if(C.delay>e.maxDelay){return false;}if(C.delay>e.minDelay){return n(o);}return true;}function n(o,p){p=p||1;var C=t[o];if(C.initiator&&t[C.initiator]){if(C.delay==t[C.initiator].delay){if(p>=e.maxDepth){return false;}return n(C.initiator,p+1);}}return true;}return{hasPending:function(){var B=Object.keys(t).filter(function(o){return m(o);});var H=B.length>0;k(B);return H;},extendConfig:function(C){C=C&&C.timeoutWaiter||{maxDepth:d,maxDelay:D};c.validate({inputToValidate:C,validationInfo:{maxDepth:"numeric",maxDelay:"numeric",minDelay:"numeric"}});q.extend(e,C);}};},true);
