/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/thirdparty/jquery','sap/ui/core/Control','sap/ui/core/Popup','./library','./OverlayRenderer','sap/ui/core/library','sap/ui/dom/jquery/control','sap/ui/dom/jquery/Focusable'],function(q,C,P,l,O,c){"use strict";var a=c.OpenState;var b=C.extend("sap.ui.ux3.Overlay",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.ui.ux3",properties:{openButtonVisible:{type:"boolean",group:"Misc",defaultValue:true},closeButtonVisible:{type:"boolean",group:"Misc",defaultValue:true}},events:{close:{allowPreventDefault:true,parameters:{id:{type:"string"}}},closed:{allowPreventDefault:true,parameters:{id:{type:"string"}}},openNew:{parameters:{id:{type:"string"}}},open:{parameters:{id:{type:"string"}}}}}});b.prototype.init=function(){var t=this;this._oPopup=new P(this,false,true);this._oPopup.attachOpened(function(e){var d=q(document.getElementById(t._initialFocusId))[0];if(!d&&t._getShell()&&t.getOpenButtonVisible()){d=document.getElementById(t._getOpenButtonId());}else if(!d&&t._getShell()&&t.getCloseButtonVisible()){d=document.getElementById(t._getCloseButtonId());}else if(!d){d=t.$("content").firstFocusableDomRef();}if(!d){d=t.$().firstFocusableDomRef();}if(d){d.focus();}});this._oPopup.attachClosed(function(e){t.fireClosed({id:t.getId()});});this._overridePopupEventing();};b.prototype._overridePopupEventing=function(){this._oPopup.onmousedown=function(e){return;};};b.prototype._getShell=function(){var s=q(".sapUiUx3Shell").control();if(s.length>0&&!this._oShell){this._oShell=s.length?s[0]:null;}return this._oShell;};b.prototype._getCloseButtonId=function(){return this.getId()+"-close";};b.prototype._getOpenButtonId=function(){return this.getId()+"-openNew";};b.prototype._initDom=function(f,F,A){var s=q(".sapUiUx3Shell").control();this._oShell=s.length?s[0]:null;s=this._oShell;this.$().css("position","fixed");if(s){this._bFocusEventsRegistered=true;s.syncWithCanvasSize(this.getId(),true,f,F,A);this.$("firstFocusDummyPaneFw").attr("tabindex","0").on("focusin",q.proxy(s.focusFirstHdr,s));this.$("firstFocusDummyPaneBw").attr("tabindex","0").on("focusin",q.proxy(s.focusLastTool,s));this.$("LastFocusDummyPane").attr("tabindex","0").on("focusin",q.proxy(s.focusPaneStart,s));}else{this.$().css("bottom","0").css("top","0").css("left","0").css("right","0");}};b.prototype._cleanupDom=function(){if(this._oShell){this._oShell.syncWithCanvasSize(this.getId(),false);}if(this._bFocusEventsRegistered){this._bFocusEventsRegistered=false;this.$("firstFocusDummyPaneFw").removeAttr("tabindex").off("focusin");this.$("firstFocusDummyPaneBw").removeAttr("tabindex").off("focusin");this.$("LastFocusDummyPane").removeAttr("tabindex").off("focusin");}};b.prototype.onAfterRendering=function(){var p=this._oPopup.getOpenState();if(p===a.OPEN||p===a.OPENING){this._initDom(q.proxy(this._setFocusFirst,this),q.proxy(this._setFocusLast,this),q.proxy(this._applyChanges,this));}};b.prototype.onBeforeRendering=function(){};b.prototype.exit=function(){this.close();this._oPopup.destroy();this._oPopup=null;this._oShell=null;};b.prototype.open=function(i){this._initialFocusId=i;if(this._oPopup.isOpen()){return;}if(i){this._oPopup.setInitialFocusId(i);}this._oPreviousFocus=P.getCurrentFocusInfo();this._oPopup.open(400);this._initDom(q.proxy(this._setFocusFirst,this),q.proxy(this._setFocusLast,this),q.proxy(this._applyChanges,this));this.fireOpen({id:this.getId()});};b.prototype.close=function(){if(!this._oPopup.isOpen()){return;}this._oPopup.close(400);setTimeout(this.restorePreviousFocus.bind(this),400);this._cleanupDom();};b.prototype.onclick=function(e){this._handleButtonEvent(e);};b.prototype.onsapselect=function(e){this._handleButtonEvent(e);};b.prototype._handleButtonEvent=function(e){var d=e.target.id;if(d===this._getCloseButtonId()){if(this.fireClose({id:this.getId()})){this.close();}}else if(d===this._getOpenButtonId()){this.fireOpenNew({id:this.getId()});}};b.prototype._getText=function(k,A){var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.ux3");var t;if(r){t=r.getText(k);}if(t&&A){for(var i=0;i<A.length;i++){t=t.replace("{"+i+"}",A[i]);}}return t?t:k;};b.prototype._setFocusFirst=function(){var e=document.getElementById(this._getOpenButtonId());if(e){e.focus();}};b.prototype._setFocusLast=function(){var e=document.getElementById(this._getCloseButtonId());if(e){e.focus();}};b.prototype._applyChanges=function(o){return this;};b.prototype.isOpen=function(){return this._oPopup.isOpen();};b.prototype.restorePreviousFocus=function(){P.applyFocusInfo(this._oPreviousFocus);};return b;});
